package com.malk.mc.controller;


import com.alibaba.fastjson.JSONObject;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import com.malk.utils.PublicUtil;
import com.malk.utils.UtilMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;

/***
 * 宜搭服务
 */
@RestController
@RequestMapping("/yd/")
public class McYdController {

    @Autowired
    private YDService ydService;
    @Autowired
    private YDClient ydClient;

    /***
     * 复制表单数据到另一个表
     * @param param
     * @return
     */
    @PostMapping("copy")
    public McR copy(@RequestBody JSONObject param){
        if(PublicUtil.isNull(param,"instanceId","formUuid")){
            return McR.errorNullPointer();
        }
        ydService.mirrorFormData(param.getString("instanceId"),param.getString("formUuid"),param.getString("processCode"),
                param.getJSONObject("updateData"),param.getString("updateInstanceId"));
        return McR.success();
    }

    /***
     * 保存关联表单数据
     * @param param
     * @return
     */
    @PostMapping("saveGl")
    public McR saveGl(@RequestBody JSONObject param){
        if(PublicUtil.isNull(param,"formInstId","formUuid","title","saveFormInstId","compId","appType")){
            return McR.errorNullPointer();
        }
        ydClient.operateData(YDParam.builder().updateFormDataJson(JSONObject.toJSONString(UtilMap.map(param.getString("compId"),Arrays.asList(
                UtilMap.map("appType, formType, instanceId, title, subTitle, formUuid",param.getString("appType"),"receipt",param.getString("formInstId")
                        ,param.getString("title"),param.getString("subTitle"),param.getString("formUuid")))
        ))).formInstId(param.getString("saveFormInstId")).build(), YDConf.FORM_OPERATION.update);
        return McR.success();
    }

}
